# coding: utf-8
"""Waylay Function Registry models.

This code was generated from the OpenAPI documentation of 'Waylay Function Registry'

Generated by OpenAPI Generator (https://openapi-generator.tech)

Do not edit the class manually.

"""

from __future__ import annotations

from typing import Any

from pydantic import (
    ConfigDict,
    Field,
    StrictFloat,
    StrictInt,
    StrictStr,
)
from waylay.sdk.api._models import BaseModel as WaylayBaseModel

from ..models.asset_condition_content_type import AssetConditionContentType
from ..models.asset_condition_pattern import AssetConditionPattern
from ..models.asset_role import AssetRole


class AssetCondition(WaylayBaseModel):
    """Describes conditions on the set of files that match a file pattern.."""

    title: StrictStr | None = None
    description: StrictStr | None = None
    role: AssetRole
    pattern: AssetConditionPattern
    content_type: AssetConditionContentType | None = Field(
        default=None, alias="contentType"
    )
    min: StrictFloat | StrictInt | None = Field(
        default=None,
        description="The minimal number of files that must match this pattern. Use `0` for an optional file.",
    )
    max: StrictFloat | StrictInt | None = Field(
        default=None,
        description="The maximal number of files that can match this pattern. Use `0` for a disallowed file. This condition only raises an error if there are no other conditions that",
    )
    max_size: StrictStr | None = Field(
        default=None,
        description="The maximum size for each file matching this pattern (in bytes, unless unit is provided)",
        alias="maxSize",
    )
    var_schema: Any | None = Field(
        default=None,
        description="The json schema validator that applies (in case of `application/json` entries).",
        alias="schema",
    )

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
        extra="ignore",
    )
