# coding: utf-8
"""Waylay Function Registry models.

This code was generated from the OpenAPI documentation of 'Waylay Function Registry'

Generated by OpenAPI Generator (https://openapi-generator.tech)

Do not edit the class manually.

"""

from __future__ import annotations

import re

from pydantic import (
    ConfigDict,
    Field,
    StrictBool,
    StrictStr,
    field_validator,
)
from typing_extensions import (
    Annotated,  # >=3.11
)
from waylay.sdk.api._models import BaseModel as WaylayBaseModel

from ..models.rebuild_policy import RebuildPolicy


class RebuildQueryV2(WaylayBaseModel):
    """RebuildQueryV2."""

    comment: StrictStr | None = Field(
        default=None,
        description="An optional user-specified comment corresponding to the operation.",
    )
    dry_run: StrictBool | None = Field(
        default=None,
        description="If set to <code>true</code>, checks whether rebuild jobs are needed, but do not start any jobs.",
        alias="dryRun",
    )
    var_async: StrictBool | None = Field(
        default=True,
        description="Unless this is set to <code>false</code>, the server will start the required job actions asynchronously and return a <code>202</code> <em>Accepted</em> response. If <code>false</code> the request will block until the job actions are completed, or a timeout occurs.",
        alias="async",
    )
    upgrade: RebuildPolicy | None = None
    force_version: Annotated[str, Field(strict=True)] | None = Field(
        default=None,
        description="A semantic version with _exactly_ a `major`, `minor` and `patch` specifier. No `pre-release` or `build` identifiers are allowed. See https://semver.org",
        alias="forceVersion",
    )
    ignore_checks: StrictBool | None = Field(
        default=None,
        description="If set to true, checks that normally prevent a rebuild are overriden. These checks include: * function state in `pending`, `running`, `failed` or `undeployed` * backoff period due to recent failures * usage of deprecated dependencies * running jobs on entity * the `dryRun` option",
        alias="ignoreChecks",
    )
    scale_to_zero: StrictBool | None = Field(
        default=None,
        description="Indicates whether the function needs to be scaled down after successful (re-)deployment. If not set, the function is scaled to zero only if it was not active before this command.",
        alias="scaleToZero",
    )
    skip_rebuild: StrictBool | None = Field(
        default=None,
        description="If set, the function will not be rebuild. Always uses the current runtime version when re-deploying/re-verifying the function.",
        alias="skipRebuild",
    )

    @field_validator("force_version")
    @classmethod
    def force_version_validate_regular_expression(cls, value):
        """Validate the regular expression."""
        if value is None:
            return value
        if not re.match(r"^(0|[1-9]\d*)\.(0|[1-9]\d*)\.(0|[1-9]\d*)$", value):
            raise ValueError(
                r"must validate the regular expression /^(0|[1-9]\d*)\.(0|[1-9]\d*)\.(0|[1-9]\d*)$/"
            )
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
        extra="ignore",
    )
