# coding: utf-8
"""Waylay Function Registry models.

This code was generated from the OpenAPI documentation of 'Waylay Function Registry'

Generated by OpenAPI Generator (https://openapi-generator.tech)

Do not edit the class manually.

"""

from __future__ import annotations

from typing import List

from pydantic import (
    ConfigDict,
    Field,
    StrictBool,
)
from waylay.sdk.api._models import BaseModel as WaylayBaseModel

from ..models.assets_conditions import AssetsConditions
from ..models.build_spec import BuildSpec
from ..models.deploy_spec import DeploySpec
from ..models.language_release import LanguageRelease
from ..models.provided_dependency import ProvidedDependency


class RuntimeSpecification(WaylayBaseModel):
    """Runtime (version) specification that says * what assets are required/allowed to build the function * what build parameters are used * what deployment parameters are used * which dependencies are provided by the runtime."""

    build: BuildSpec | None = None
    deploy: DeploySpec | None = None
    language: LanguageRelease | None = None
    provided_dependencies: List[ProvidedDependency] | None = Field(
        default=None,
        description="Description of dependencies provided by this runtime version.",
        alias="providedDependencies",
    )
    assets: AssetsConditions | None = None
    deprecated: StrictBool | None = Field(
        default=None,
        description="If true, this runtime should no longer be used for new functions.",
    )

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
        extra="ignore",
    )
